import { IconButton } from '@suid/material';
import { Component, createSignal } from 'solid-js';

import NoteIcon from '@suid/icons-material/Note';

import style from './Note.module.css';

interface Props {}

const Note: Component<Props> = (props) => {
  const [open, setOpen] = createSignal<boolean>();

  return (
    <>
      <div
        class={
          window.Capacitor.platform === 'web'
            ? style.control_web
            : style.control
        }
      >
        {' '}
        <IconButton
          onClick={() => {
            setOpen(true);
          }}
        >
          <NoteIcon />
        </IconButton>
      </div>
    </>
  );
};

export default Note;
