import getUri, { intToTrkptId } from '../lib/ids';
import { put } from './lib';
import { getTrksegDocs, putTrkseg } from './trkseg';
import { emptyWpt } from './wpt';

const emptyTrkpt: Wpt = {
  $: { lat: 0, lon: 0 },
  ele: undefined,
  time: undefined,
  magvar: undefined,
  geoidheight: undefined,
  name: undefined,
  cmt: undefined,
  desc: undefined,
  src: undefined,
  link: undefined,
  sym: undefined,
  type: undefined,
  fix: undefined,
  sat: undefined,
  hdop: undefined,
  vdop: undefined,
  pdop: undefined,
  ageofdgpsdata: undefined,
  dgpsid: undefined,
  extensions: {
    'dyo:speed': undefined,
    'dyo:course': undefined,
    'dyo:accuracy': undefined,
    'dyo:batterylevel': undefined,
    'dyo:useragent': undefined,
  },
};

export const putTrkpt = async (params: any) => {
  const { id, index, wpt } = params;
  const { docs } = await getTrksegDocs({ id: id });
  const trkseg = docs.rows[0].doc.doc;
  const nbWptInTrkseg = trkseg && trkseg.trkpt ? trkseg.trkpt.length : 0;
  const nbWptOutTrkseg = docs.rows.length - 1;
  const nbWpt = nbWptInTrkseg + nbWptOutTrkseg;
  const positiveIndex = index >= 0 ? index : nbWpt + index;
  console.log({
    caller: 'putTrkpt',
    nbWptInTrkseg,
    nbWptOutTrkseg,
    nbWpt,
    positiveIndex,
    trkpt: JSON.stringify(trkseg.trkpt),
  });
  if (positiveIndex < nbWptInTrkseg) {
    trkseg.trkpt[positiveIndex] = wpt;
    await putTrkseg(id, trkseg);
  } else {
    const trkptId = docs.rows[1 + positiveIndex - nbWptInTrkseg].doc._id;
    await put(trkptId, 'trkpt', () => wpt, emptyWpt);
  }
  return wpt;
};
